From a3165c2264df0a7163b0e67fb0fe302a95ed38c0 Mon Sep 17 00:00:00 2001
From: David Carlos <ddavidcarlos1392@gmail.com>
Date: Mar 16 2018 02:30:30 +0000
Subject: [PATCH 9/17] WIP: Refactoring runner code.


---

diff --git a/kiskadee/fetchers/__init__.py b/kiskadee/fetchers/__init__.py
index 29b5cf3..b61511b 100644
--- a/kiskadee/fetchers/__init__.py
+++ b/kiskadee/fetchers/__init__.py
@@ -93,6 +93,9 @@ class Fetcher(abc.ABC):
             download_path = os.path.join(path, file_name)
             with open(download_path, 'wb') as info:
                 info.write(data)
+            kiskadee.logger.debug(
+                    "Downloaded {} source in {} path".format(file_name, path)
+                    )
             return download_path
         except Exception as err:
             kiskadee.logger.debug(
diff --git a/kiskadee/monitor.py b/kiskadee/monitor.py
index 12eaad1..9490b2a 100644
--- a/kiskadee/monitor.py
+++ b/kiskadee/monitor.py
@@ -22,41 +22,35 @@ class Monitor:
     def __init__(self, _session, queues):
         """Return a non initialized Monitor."""
         self.session = _session
-        self.kiskadee_queue = queues
+        self.queues = queues
 
     def start(self):
-        kiskadee.logger.debug('kiskadee PID: {}'.format(os.getppid()))
-        kiskadee.logger.debug('Starting monitor subprocess')
-        kiskadee.logger.debug('monitor PID: {}'.format(os.getpid()))
+        kiskadee.logger.debug('Monitor PID: {}'.format(os.getpid()))
 
         for fetcher in kiskadee.load_fetchers():
             thread = Monitor._start_fetcher(fetcher.Fetcher().watch)
 
         while RUNNING:
-            new_project = self.dequeue_from_fetchers()
+            new_project = self.dequeue_project_from_fetchers()
             self.send_project_to_runner(new_project)
             analyzed_project = self.dequeue_analysis_from_runner()
             self.save_analyzed_project(analyzed_project)
 
     def dequeue_project_from_fetchers(self):
-        new_project = self.kiskadee_queue.dequeue_project()
+        new_project = self.queues.dequeue_project()
         return new_project if new_project else {}
 
     def dequeue_analysis_from_runner(self):
-        return self.kiskadee_queue.dequeue_result()
+        return self.queues.dequeue_result()
 
     def send_project_to_runner(self, data):
         if data:
             fetcher, project = self.get_fetcher_and_project(data)
             data["fetcher_id"] = fetcher.id if fetcher else ''
             if not project:
-                kiskadee.logger.debug(
-                        "MONITOR: Sending project {}_{} "
-                        " for analysis".format(data['name'], data['version'])
-                )
-                self.kiskadee_queue.enqueue_analysis(data)
-            elif self.not_analyzed_project_version(project, data):
-                self.kiskadee_queue.enqueue_analysis(data)
+                self.queues.enqueue_analysis(data)
+            elif self.is_a_new_project_version(project, data):
+                self.queues.enqueue_analysis(data)
 
     def get_fetcher_and_project(self, data):
         fetcher_name = data['fetcher'].split('.')[-1]
@@ -65,7 +59,7 @@ class Monitor:
         project = self._query(Package).filter_by(name = project_name).first()
         return fetcher, project
 
-    def not_analyzed_project_version(self, project, data):
+    def is_a_new_project_version(self, project, data):
         project_version = data['version']
         analysed_version = project.versions[-1].number
         fetcher = importlib.import_module(data['fetcher']).Fetcher()
@@ -102,13 +96,12 @@ def daemon():
     queues = kiskadee.queue.Queues()
     session = kiskadee.database.Database().session
     monitor = Monitor(session, queues)
-    runner = Runner()
+    runner = Runner(session, queues)
     monitor_process = Process(
             target=monitor.start,
         )
     runner_process = Process(
             target=runner.runner,
-            args=(queues,)
         )
     monitor_process.start()
     runner_process.start()
diff --git a/kiskadee/queue.py b/kiskadee/queue.py
index 959be72..672958a 100644
--- a/kiskadee/queue.py
+++ b/kiskadee/queue.py
@@ -42,17 +42,33 @@ class Queues():
     @staticmethod
     def enqueue_analysis(project_to_analysis):
         """Put a analysis on the analysis queue."""
+        log_msg = "Sending project {}_{} for analysis"\
+                .format(project_to_analysis['name'],
+                        project_to_analysis['version'])
+        kiskadee.logger.debug(log_msg)
         analysis.put(project_to_analysis)
 
     @staticmethod
     def dequeue_analysis():
         """Get a analysis from the analysis queue."""
-        return analysis.get()
+        project_to_analysis = analysis.get()
+        kiskadee.logger.debug(
+                'RUNNER: deqeued {}-{} from {}'
+                .format(project_to_analysis['name'],
+                        project_to_analysis['version'],
+                        project_to_analysis['fetcher'])
+            )
+        return project_to_analysis
 
     @staticmethod
-    def enqueue_result(result):
+    def enqueue_result(project):
         """Put a result on the results queue."""
-        results.put(result)
+        kiskadee.logger.debug(
+                "RUNNER: Sending {}-{} to Monitor"
+                .format(project["name"],
+                        project["version"])
+            )
+        results.put(project)
 
     @staticmethod
     @empty_queue
diff --git a/kiskadee/runner.py b/kiskadee/runner.py
index 8fd8de7..607fdef 100644
--- a/kiskadee/runner.py
+++ b/kiskadee/runner.py
@@ -16,9 +16,12 @@ RUNNING = True
 class Runner:
     """Provide kiskadee runner objects."""
 
-    def __init__(self):
+    def __init__(self, session, queues):
         """Return a non initialized Runner."""
-        self.queues = None
+        self.queues = queues
+        self.session = session
+        kiskadee.model.Analyzer.create_analyzers(self.session)
+        self.fetcher = None
 
     def runner(self, queues):
         """Run static analyzers.
@@ -27,52 +30,69 @@ class Runner:
         :func:`analyze` method, passing the dequeued package.
         After the analysis, updates the status of this package on the database.
         """
-        kiskadee.logger.debug('Starting runner subprocess')
-        kiskadee.logger.debug('runner PID: {}'.format(os.getpid()))
-        session = kiskadee.database.Database().session
-        kiskadee.model.Analyzer.create_analyzers(session)
-        self.queues = queues
+        kiskadee.logger.debug('Runner PID: {}'.format(os.getpid()))
         while RUNNING:
             kiskadee.logger.debug('RUNNER: Waiting to dequeue'\
                                   ' project to analysis...')
-            source_to_analysis = self.queues.dequeue_analysis()
-            kiskadee.logger.debug(
-                    'RUNNER: deqeued {}-{} from {}'
-                    .format(source_to_analysis['name'],
-                            source_to_analysis['version'],
-                            source_to_analysis['fetcher'])
+            project_to_analysis = self.queues.dequeue_analysis()
+            self.call_analyzers(project_to_analysis)
+
+    def load_project_fetcher(self, project_to_analysis):
+        try:
+        return importlib.import_module(
+                project_to_analysis['fetcher']
+                ).Fetcher()
+        except ModuleNotFoundError:
+            kiskadee.logger.debug("Fetcher {} could not be loaded"\
+                    .format(project_to_analysis['fetcher'])
                 )
-            self.call_analyzers(source_to_analysis)
+            return {}
+
+    def uncompress_project_code(self, compressed_source):
+        dir_to_unpack_source = tempfile.mkdtemp()
+        try:
+            shutil.unpack_archive(compressed_source,
+                    dir_to_unpack_source)
+            return dir_to_unpack_source
+        except Exception as err:
+            kiskadee.logger.debug('Could not unpack project source')
+            kiskadee.logger.debug(err)
+            return {}
+
+    def run_analysis(self, analyzers, project_to_analysis):
+        project_to_analysis['results'] = {}
+        for analyzer in analyzers:
+            firehose_report = self.analyze(analyzer, source_path)
+            if firehose_report:
+                project_to_analysis['results'][analyzer] = firehose_report
+        return project_to_analysis
 
-    def call_analyzers(self, source_to_analysis):
+
+    def clean_temporary_directory(self, dir):
+        # not delete the source code used on tests.
+        if not compressed_source_path .find("kiskadee/tests") > -1:
+            shutil.rmtree(os.path.dirname(dir))
+
+    def call_analyzers(self, project_to_analysis):
         """Iterate over the package analyzers.
 
         For each analyzer defined to analysis the source, call
         the function :func:`analyze`, passing the source dict, the analyzer
         to run the analysis, and the path to a compressed source.
         """
-        fetcher = importlib.import_module(source_to_analysis['fetcher']).Fetcher()
-        source_path = self._path_to_uncompressed_source(
-                source_to_analysis, fetcher
-        )
+        self.fetcher = self.load_project_fetcher(project_to_analysis)
+        source_path = self.prepare_to_get_project_code(project_to_analysis)
         if not source_path:
             return None
 
         analyzers = fetcher.analyzers()
-        source_to_analysis['results'] = {}
-        for analyzer in analyzers:
-            firehose_report = self.analyze(analyzer, source_path)
-            if firehose_report:
-                source_to_analysis['results'][analyzer] = firehose_report
+        analysis_result = self.run_analysis(analyzers, project_to_analysis)
+        self.enqueue_analysis_to_monitor(analysis_result)
+        self.clean_temporary_directory(source_path)
 
-        if source_to_analysis['results']:
-            kiskadee.logger.debug(
-                    "RUNNER: Sending {}-{} to Monitor"
-                    .format(source_to_analysis["name"],
-                            source_to_analysis["version"])
-                )
-            self.queues.enqueue_result(source_to_analysis)
-        shutil.rmtree(source_path)
+    def enqueue_analysis_to_monitor(self, analysis_result):
+        if analysis_result['results']:
+            self.queues.enqueue_result(analysis_result)
 
     def analyze(self, analyzer, source_path):
         """Run each analyzer on some sorce code.
@@ -101,52 +121,18 @@ class Runner:
             kiskadee.logger.debug(err)
             return None
 
-    def _path_to_uncompressed_source(self, package, fetcher):
+    def prepare_to_get_project_code(self, project):
 
-        if not (fetcher and package):
+        if not (self.fetcher and project):
             return None
 
-        kiskadee.logger.debug(
-                'ANALYSIS: Downloading {} '
-                'source...'.format(package['name'])
-        )
-
-        compressed_source = fetcher.get_sources(package)
-
-        if compressed_source:
-            kiskadee.logger.debug(
-                    'ANALYSIS: Downloaded {} source in {} path'
-                    .format(
-                        package['name'],
-                        os.path.dirname(compressed_source)
-                    )
-                )
-            tmp_path = tempfile.gettempdir()
-            uncompressed_source_path = tempfile.mkdtemp(dir=tmp_path)
-            try:
-                shutil.unpack_archive(
-                        compressed_source,
-                        uncompressed_source_path
+        compressed_source_path = self.fetcher.get_sources(project)
+        if compressed_source_path :
+            uncompressed_source_path = uncompress_project_code(
+                    compressed_source_path
                     )
-                kiskadee.logger.debug(
-                        'ANALYSIS: Unpacking {} source in {} path'
-                        .format(package['name'], uncompressed_source_path)
-                        )
-                # not delete the source code used on tests.
-                if not compressed_source.find("kiskadee/tests") > -1:
-                    shutil.rmtree(os.path.dirname(compressed_source))
-                    kiskadee.logger.debug(
-                            'ANALYSIS: Remove {} temp directory'
-                            .format(os.path.dirname(compressed_source))
-                        )
-                kiskadee.logger.debug(
-                        'ANALYSIS: Unpacked {} source'.format(package['name'])
-                        )
-                return uncompressed_source_path
-            except Exception as err:
-                kiskadee.logger.debug('Something went wrong')
-                kiskadee.logger.debug(err)
-                return None
+            self.clean_temporary_directory(os.path.dirname(compressed_source_path))
+            return uncompressed_source_path
         else:
             kiskadee.logger.debug('RUNNER: invalid compressed source')
             return None
diff --git a/kiskadee/tests/integration/test_monitor.py b/kiskadee/tests/integration/test_monitor.py
index eae9829..3018563 100644
--- a/kiskadee/tests/integration/test_monitor.py
+++ b/kiskadee/tests/integration/test_monitor.py
@@ -40,46 +40,6 @@ class MonitorTestCase(unittest.TestCase):
                     'flawfinder': '><'},
                 'fetcher_id': 1}
 
-        self.data2 = {'name': 'urlscan',
-                'version': '0.8.2',
-                'fetcher': kiskadee.fetchers.debian.__name__,
-                'meta': {'directory': 'pool/main/u/urlscan'},
-                'results': {
-                    'cppcheck': '<>',
-                    'flawfinder': '><'},
-                'fetcher_id': 1}
-
-        self.data3 = {'name': 'curl',
-                'version': '7.52.2-5',
-                'fetcher': kiskadee.fetchers.debian.__name__,
-                'meta': {'directory': 'pool/main/c/curl'},
-                'results': {
-                    'cppcheck': '<>',
-                    'flawfinder': '><'},
-                'fetcher_id': 1}
-        self.data4 = {'name': 'urlanitya',
-                'version': '0.11',
-                'fetcher': kiskadee.fetchers.anitya.__name__,
-                'meta': {
-                    'backend': 'gitHub',
-                    'homepage': 'https://github.com/GesielFreitas/Cros'
-                    },
-                'results': {
-                    'cppcheck': '<>',
-                    'flawfinder': '><'},
-                'fetcher_id': 1}
-        self.analysis = {
-                'analyzer_id': 1,
-                'id': 1,
-                'raw': {
-                    'results': [
-                        {'severity': 'warning'},
-                        {'severity': 'style'},
-                        {'severity': 'error'}
-                        ]
-                    }
-                }
-
     def test_dequeue_project_from_fetcher(self):
         self.example_fetcher.watch()
         monitored_project = self.monitor.dequeue_project_from_fetchers()
@@ -107,19 +67,12 @@ class MonitorTestCase(unittest.TestCase):
         self.monitor.get_fetcher_and_project = MagicMock(
                 return_value=[fetcher, {}]
                 )
-        self.monitor.not_analyzed_project_version = MagicMock(
+        self.monitor.is_a_new_project_version = MagicMock(
                 return_value=True
                 )
         self.monitor.send_project_to_runner(self.data1)
-        self.assertEqual(self.monitor.kiskadee_queue.dequeue_analysis(), self.data1)
-
-    @unittest.skip("will implement")
-    def test_receive_analysis_from_runner(self):
-        pass
-
-    @unittest.skip("will implement")
-    def test_save_analysed_runner_project(self):
-        pass
+        self.assertEqual(self.monitor.queues.dequeue_analysis(),
+                self.data1)
 
         if __name__ == '__main__':
             unittest.main()

